# -*- coding: utf_8 -*-
import direct.directbase.DirectStart
from pandac.PandaModules import *
from direct.task import Task
from direct.actor import Actor
from direct.interval.IntervalGlobal import *
from direct.showbase import DirectObject   
from pandac.PandaModules import Vec3
import sys,math
from pandac.PandaModules import AmbientLight,DirectionalLight
##
from pandac.PandaModules import PerspectiveLens
from pandac.PandaModules import NodePath
from pandac.PandaModules import AmbientLight,DirectionalLight
from pandac.PandaModules import PointLight,Spotlight
from pandac.PandaModules import TextNode
from pandac.PandaModules import Vec4
from direct.gui.OnscreenText import OnscreenText
#from direct.showbase.DirectObject import DirectObject
import  colorsys
##
#from direct.showbase.DirectObject import DirectObject

from direct.gui.OnscreenText import OnscreenText
from direct.gui.DirectGui import *
##
def restrain(i, mn = 0, mx = 1): return min(max(i, mn), mx)
##
#zagruzka modeli okrujeniya
environ = loader.loadModel("models/Poligon_Exp_5")
environ.reparentTo(render)
environ.setScale(2,2,2) 
environ.setPos(0,0,-20)

#zagruzka moddeli i animacii
pandaActor = Actor.Actor("Pokatigoroshek_anim_3",
{"walk":"Pokatigoroshek_anim_3-_Beg_Vpered",
"stop":"Pokatigoroshek_anim_3-Stoyka",
"vprav":"Pokatigoroshek_Anim-Vprav"})
#pandaActor.setBlend(frameBlend = True)
pandaActor.setScale(2,2,2) 
pandaActor.setPos(0,0,-4)
#pandaActor.reparentTo(render)
avatar = render.attachNewNode('avatar')  ## avatar Это пучтышка -Самый главный в иерархии ###!!!attachNewNode - метод класса NodePath, добавляющий новый нод 
pandaActor.reparentTo(avatar) ## pandaActor  крепиться к avatar
avatar.setPos(0,0,540)

camCenter = render.attachNewNode('camCenter') 
camCenter.reparentTo(avatar) ##  camCenter крепим к avatar
camCenter.setZ(0.5)
base.camera.reparentTo(camCenter) ## КАмеру крепим к КамероЦентру


base.camera.lookAt(camCenter)


base.disableMouse()# Убираем базовое управление  мышью
#nash klass dlya upravleniya akterom
def point_dist(p1,p2):
    return math.sqrt((p1[0]-p2[0])**2+(p1[1]-p2[1])**2+(p1[2]-p2[2])**2)
class KeyHandler(DirectObject.DirectObject):
    def __init__(self):
        ###
##            self.disco = loader.loadModel("models/disco_hall")
##            self.disco.reparentTo(render)
##            self.disco.setPosHpr(0, 50, -4, 90, 0, 0)
            #render.setShaderAuto() 
            # First we create an ambient light. All objects are affected by ambient
            # light equally
            #Create and name the ambient light
            self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ) )
            #Set the color of the ambient light
            self.ambientLight.node().setColor( Vec4( .1, .1, .1, 1 ) )
            #add the newly created light to the lightAttrib

            # Now we create a directional light. Directional lights add shading from a
            # given angle. This is good for far away sources like the sun
            self.directionalLight = render.attachNewNode( DirectionalLight( "directionalLight" ) )
            self.directionalLight.node().setColor( Vec4( .35, .35, .35, 1 ) )
            # The direction of a directional light is set as a 3D vector
            self.directionalLight.node().setDirection( Vec3( 1, 1, -2 ) )


            #Finally we store the lights on the root of the scene graph.
            #This will cause them to affect everything in the scene.

            render.setLight( self.ambientLight )
            render.setLight( self.directionalLight )



            # listen to keys for controlling the lights
            self.accept( "escape", sys.exit)
            self.accept( "z", self.addBrightnessAmb, [self.ambientLight, -.25] )
            self.accept( "x", self.addBrightnessAmb, [self.ambientLight, .25] )
            self.accept( "c", self.addBrightnessDir, [self.directionalLight, -.05] )
            self.accept( "v", self.addBrightnessDir, [self.directionalLight, .05] )
            
            
            #self.accept("r-up",self.setKey,["hz",0])
  
        ###
            self.keyMap = {"left":0, "right":0, "vpered":0, "cam-left":0, "cam-right":0, "nazad":0,"jump":0,"scr_vp":0,"scr_nz":0}###типа кнопки но  ХЗ зачем
                      
            base.cTrav = CollisionTraverser()#предположительно общее обьявление колизий
            self.trav=CollisionTraverser()
##### Сфера
            cn1 = CollisionNode('')           
            cn1.addSolid(CollisionSphere(0,0,-2,1.5))###Сфера используеться для проверки колизий сквозь горизонтальные обьекты (не terrain)
            solid = avatar.attachNewNode(cn1)## attachNewNode - метод класса NodePath, добавляющий новый нод (cn имя нода)
           # self.pusher1 = CollisionHandlerPusher()        
##            base.cTrav.addCollider(solid,self.pusher1)
##            self.pusher1.addCollider(solid,avatar, base.drive.node())
######## Конец Сферы
           
### ### ###
##            cn = CollisionNode('')           
##            cn.addSolid(CollisionSphere(0,0,-2,1.3))###Сфера используеться для проверки колизий сквозь горизонтальные обьекты (не terrain)
##            solid = avatar.attachNewNode(cn)## attachNewNode - метод класса NodePath, добавляющий новый нод (cn имя нода)          
            self.envCollision = CollisionHandlerQueue()     
            self.trav.addCollider(solid,self.envCollision) 
### ### ### 

            base.cTrav.showCollisions(render)### Просто показует все Колизии и не зависит ни от кого !!   
            
            ray = CollisionRay()# главный луч ## изходит НЕ из сферы
            ray.setOrigin(0,0,-0.2)#cмещение главного луча ## не понятно зачем
            ray.setDirection(0,0,-1) # направление главного луча вниз
            cn = CollisionNode('')
            cn.addSolid(ray)
            #cn.setFromCollideMask(BitMask32.bit(0))
            cn.setIntoCollideMask(BitMask32.allOff())
            solid = avatar.attachNewNode(cn)
            
            self.avatarGroundHandler = CollisionHandlerQueue()     
            base.cTrav.addCollider(solid,self.avatarGroundHandler) 
            
             
            #CamRay1
            camRay = CollisionRay()
            camRay.setOrigin(0,-0.2,0)
            camRay.setDirection(0,-1,0)
            cn =CollisionNode('camRay1')
            cn.addSolid(camRay)
            cn.setIntoCollideMask(BitMask32.allOff())
            solid = camCenter.attachNewNode(cn)
            solid.setX(-0.5)
            #solid.show()
            self.avatarCamHandler1 = CollisionHandlerQueue()           
            base.cTrav.addCollider(solid, self.avatarCamHandler1)
##            
##            #CamRay2
##            camRay = CollisionRay()
##            camRay.setOrigin(0,-0.2,0)
##            camRay.setDirection(0,-1,0)
##            cn =CollisionNode('camRay2')
##            cn.addSolid(camRay)
##            cn.setIntoCollideMask(BitMask32.allOff())
##            solid = camCenter.attachNewNode(cn)
##            solid.setX(0.5)
##            #solid.show()
##            self.avatarCamHandler1 = CollisionHandlerQueue()
##            base.cTrav.addCollider(solid, self.avatarCamHandler1)
        
        
         #   base.cTrav.addCollider(solid, self.avatarCamHandler1)
        
            ############################################# Конец Colision
### Ambient
            self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ) )
       #Set the color of the ambient light
            self.ambientLight.node().setColor( Vec4( 1.35, 1.01, 1.01, 1 ) )#( .1, .1, .1, 1 )
            render.setLight( self.ambientLight )
####
            #peremennye skorosti peremescheniya i povorota
            self.speed=0
            self.ws=0
            self.ad=0
            self.speedX=0
            self.speedY=0
            self.amb=0
            self.dir=0
            #registriruem sobytiya reagiruyuschie na klaviaturu
            #Zamechanie: modifikator masshtaba, primenennyy k nodu   
            #tak je deystvuet i na peremescheniya, poetomu skorost'   
            #stavim dovol'no bol'shuyu
            self.accept("escape", sys.exit)            
            self.accept("a", self.setKey_Left, ["left",1])
            self.accept("d", self.setKey_Left, ["right",1])
            self.accept("w", self.setKey_Vper, ["vpered",1])
            self.accept("s", self.setKey_Vper, ["nazad",1])
            self.accept("a-up", self.setKey_Left, ["left",0])
            self.accept("d-up", self.setKey_Left, ["right",0])
            self.accept("w-up", self.setKey_Vper, ["vpered",0])
            self.accept("s-up", self.setKey_Vper, ["nazad",0])
            self.accept("space",self.setKey_Vper,["jump",1])
            self.accept("space-up",self.setKey_Vper,["jump",0])
            ## скрол мыши
            self.accept("wheel_up",self.Scrol,["","scr_vp",1])
            self.accept("wheel_down",self.Scrol,["","scr_nz",1])
            
            

            #registriruem zadachu peremescheniya aktera         

            #base.camera.lookAt(0,30,0)# Указываем куда смотреть камере
            #self.dragging=False
            self.target=Vec3()
            ###     
            self.NX=0   ## эта переменная запоминает смещение курсора (счетчик) по Х
            self.Av_NX=0## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной Пустышки Avatar
            self.Pa_NX=0## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной панда Актер
            self.NY=0   ## эта переменная запоминает смещение курсора (счетчик) по Y
            self.sens=0.3
            self.jump=0
            self.n=0 # для поворота Панда актер
            self.m=0 #для запоминания угла  кам  больше 180 или меньше
            self.camDist=0 #для запоминания дистанции камеры
            self.dist=0
            ###                   
            taskMgr.add(self.moveTask,"moveTask") #вызываем функцию moveTask 
            taskMgr.add(self.jumpUpdate, 'jump-task')        
            
            pandaActor.loop("stop")
            #pandaActor.getAnimControl("stop").setPlayRate(1)
            base.camera.setY(-25)## отодвигаем камеру от центра 
            

    def Scrol(self,bas_dist,key,value):
        self.keyMap[key] =value
        if (self.keyMap["scr_vp"]!=0):
            self.camDist=self.camDist+1
        if (self.keyMap["scr_nz"]!=0):
            self.camDist=self.camDist-1
        if self.camDist>15:  self.camDist=self.camDist-1 ## оганичение: если ближе 15 то предыдущее
        if self.camDist<-70: self.camDist=self.camDist+1 ## оганичение: если дальше -70 то предыдущее
        self.keyMap["scr_vp"]=0
        self.keyMap["scr_nz"]=0
        
        base.camera.setY(-25+self.camDist)
        if (bas_dist<-camera.getY()): #проверка dist--- расстояние камеры от центра                
                base.camera.setY(-bas_dist)
        
        
       
           
## При нажатии кнопок проигрывание анимации        
    def setKey_Vper(self, key, value):
        self.keyMap[key] = value
        pandaActor.setBlend(frameBlend=1,blendType=1)
        pandaActor.enableBlend()
        if (self.keyMap["vpered"]!=0) or  (self.keyMap["nazad"]!=0):              
            i1 = Sequence(LerpAnimInterval(pandaActor, 0.3, 'stop', 'walk'))
            i1.start()
            pandaActor.loop("walk")                
        else:
            i1 = Sequence(LerpAnimInterval(pandaActor, 0.3, 'walk', 'stop'))
            i1.start()                      
            pandaActor.loop("stop")
          ###  
    def setKey_Left(self, key, value): 
        self.keyMap[key] = value
        pandaActor.setBlend(frameBlend=1,blendType=1)
        pandaActor.enableBlend()   
        if (self.keyMap["left"]!=0) or (self.keyMap["right"]!=0):              
            i1 = Sequence(LerpAnimInterval(pandaActor, 0.3, 'stop', 'vprav'))
            i1.start()
            pandaActor.loop("vprav")           
        else:
            i1 = Sequence(LerpAnimInterval(pandaActor, 0.3, 'vprav', 'stop'))
            i1.start()                      
            pandaActor.loop("stop")
#### В ЭТОЙ ЧАСТИ ПЕРЕМЕЩЕНИЕ ПЕРСОНАЖА  И ПОВОРОТ КАМЕРЫ 
    def moveTask(self,task):
        ##  Перемещение        
        prevPos=avatar.getPos()
        if (self.keyMap["vpered"]!=0):            
            avatar.setPos(avatar,0,-0.5,0)      
        if (self.keyMap["nazad"]!=0):            
            avatar.setPos(avatar,0,0.5,0)        
        if (self.keyMap["right"]!=0):
            avatar.setPos(avatar,-0.5,0,0)
        if (self.keyMap["left"]!=0):
            avatar.setPos(avatar,0.5,0,0)
        ### Поворот
            
        Xc=base.win.getXSize()/2-base.win.getPointer(0).getX()## смещение курсора
        Yc=base.win.getYSize()/2-base.win.getPointer(0).getY()

        base.win.movePointer(0,base.win.getXSize()/2,base.win.getYSize()/2)#переводим курсов в центр
        
        ### скрол мыши
        
        #self.accept("wheel_down",lambda : self.adjustCamDist(1.1))
            ###
#        base.camera.setY(-25)## отодвигаем камеру от центра 

      #  if base.mouseWatcherNode.hasMouse():# если мышь начинает двигаться тогда :              
        self.NX=Xc+self.NX ## эта переменная запоминает смещение курсора (счетчик) по Х для camCenter
        self.Av_NX=Xc+self.Av_NX## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной Пустышки Avatar
        self.Pa_NX=Xc+self.Pa_NX## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной панда Актер
        if self.NY<=150 or self.NY>=-270  : ## ограничение чтобы камерой сильно не крутить                       
            self.NY=Yc+self.NY ## эта переменная запоминает смещение курсора (счетчик) по Y для camCenter                   
            if self.NY>150:  self.NY=self.NY-Yc ## если превысили то возвращаем в предыдущее
            if self.NY<-270: self.NY=self.NY-Yc ## если превысили то возвращаем в предыдущее
        camCenter.setH(self.NX*self.sens+180) #поворачиваем avatar к которому  прикреплена наш camCenterа потом камера
        #print 'camCenter.getH()',camCenter.getH()
        #pandaActor.setH(camCenter.getH())
        #print 'self.Pa_NX*self.sens',(-self.Pa_NX*self.sens)%360
        ug_pov=0
        if self.keyMap["vpered"]!=0 or self.keyMap["nazad"]!=0 or (self.keyMap["right"]!=0) or (self.keyMap["left"]!=0) : # Если нажимаем Вперед или назад тогда : 
                           
            avatar.setH(self.Av_NX*self.sens) # avatar поворачиваем в куда нужно
###  ###  ###   ###   ###  ###  ###  ###   ###   ###  ###  ###  ###   ###   ###  ###  ###  ###   ###   ###  ###  ###  ###   ###   ###  ###  ###  ###   ###   ###  ###  ###  ###   ###   ###  
            ug_pov=camCenter.getH()%360## Запоминаем угол поворота camCenter            
            self.NX=0 #смещение для camCenter обнуляем       
            camCenter.setH(180) #  camCenter возвращаем в начальное значение  
            self.Povorot(ug_pov)# вызываем функцию "анимации" поворота (плавно поворачиваеться) без нее будет резко
        
        camCenter.setP(self.NY*self.sens) #поворачиваем ВЕРТИКАЛЬНО camCenter к которой прикреплена наша камера         
############# Проверка КАМЕРЫ  на колизии
        #near_point=Point3(0,0,0)
        if (self.avatarCamHandler1.getNumEntries()>0):
             
            self.avatarCamHandler1.sortEntries() 
            entry = self.avatarCamHandler1.getEntry(0) 
            near_point = entry.getSurfacePoint(render)
        
            p1=avatar.getX(),avatar.getY(),avatar.getZ()
            p2=near_point.getX(),near_point.getY(),near_point.getZ()
            #print p2
            self.dist=point_dist(p1,p2)
        else : self.dist=134        
        self.Scrol(self.dist,"","")     
########### Обработка коллизий с окружающими объектами #########
        self.trav.traverse(render)
        if (self.envCollision.getNumEntries()>0):
            self.envCollision.sortEntries() 
            v_res=Vec3(0,0,0)
            max_l=0
            for i in xrange(self.envCollision.getNumEntries()):                
                    entry = self.envCollision.getEntry(i) 
                    near_point = entry.getSurfacePoint(render)
                    avatar_point=avatar.getPos(render)
                    avatar_point.setZ(avatar_point.getZ()-2)
                    v=Vec3(avatar_point)-Vec3(near_point)
                    #первая строка рассчитывает вектор в глобальных 
                    #координатах - координатах рендера, а вторая конвертирует полученный вектор 
                    #в локальные координаты персонажа чтоб сместить его в нужную сторону
                    v=avatar.getRelativeVector(render,v)
                    v_res=v_res+v
                    if v.length()<=1.5:
                        l=1.5-v.length()
                        if l>max_l:
                            max_l=l
##                        v.normalize()
##                        v=v*l
##                        avatar.setPos(avatar,v)
            v_res.normalize()
            v_res=v_res*max_l*0.8
            avatar.setPos(avatar,v_res)
            if self.envCollision.getNumEntries()>1:
                avatar.setPos(Vec3(avatar.getPos())+Vec3(Vec3(prevPos)-Vec3(avatar.getPos()))*0.8)

        return task.cont
####   ####   ####   ####   ####   ####   ####   #### 
    def Povorot(self,task):#task это типа ug_pov
            
            if task!=180 and self.keyMap["vpered"]!=0 and self.n==0:
                #self.n=(-self.Pa_NX*self.sens)# для поворота Панда актер
                self.m=task #запоминаем угол камеры в момент нажатия кнопки
                pandaActor.setH(-self.Pa_NX*self.sens)#Актеру назначаем спец смещение для него
                self.n=pandaActor.getH()   #запоминаем угол Актера             
                if self.n<-180 : self.n=self.n+360 #Если угол меньше -180 тогда переводим его в положительную полуокружность (прибавляем 360)
                if self.n> 180 : self.n=self.n-360              

            if self.n!=0 and self.m<180: #если мы не в исходном положении(self.n!=0) а запомненый угол камеры меньше 180
                pandaActor.setH(self.n-9)# -9 это типа скорость с которой актер поворачиваеться 
                self.n=self.n-9  # не забываем self.n тоже просчитывать
            if self.n!=0 and self.m>180:#если мы не в исходном положении(self.n!=0) а запомненый угол камеры ,больше 180
                pandaActor.setH(self.n+9)
                self.n=self.n+9# не забываем self.n тоже просчитывать
            if self.n<10 and self.n>-10:    #если положение актера очень близко к исходному то актера доводим до конца(ставим в исх положение) и все обнуляем 
                self.n=0
                self.m=0
                self.Pa_NX=0
                pandaActor.setH(0)
              
            

####Прыжок и притяжение
    def jumpUpdate(self,task):
        """ this task simulates gravity and makes the player jump """
        highestZ = -100 # некое знакчение к которому потом стремиться
        for i in range(self.avatarGroundHandler.getNumEntries()):
            entry = self.avatarGroundHandler.getEntry(i)
            z = entry.getSurfacePoint(render).getZ()
            if z > highestZ and entry.getIntoNode().getName() == "terrain":
                highestZ = z
               
        # gravity effects and jumps
        avatar.setZ(avatar.getZ()+self.jump*globalClock.getDt()*10)#сдесь типа задержка
        #avatar.setZ(avatar.getZ()+self.jump)
        ##### globalClock.getDt() узнаёт время,прошедшее с момента рендера последнего кадра,оно используется для организации равномерного движения объекта 
        self.jump = self.jump -50*globalClock.getDt()#высота чем меньше тем выше прыжок
                
        if highestZ > avatar.getZ()-3.9:  #глубина луча до пересечения         
            self.jump = 0
            avatar.setZ(highestZ+3.9)
            if (self.keyMap["jump"]!=0):
                self.jump = 10
        return task.cont
    def addBrightnessAmb( self, light, amount ):
            color = light.node().getColor()
            h, s, b = colorsys.rgb_to_hsv( color[0], color[1], color[2] )
            brightness = b + amount# s сделать равны 0.25
            #print 'Dir=',brightness
            #print b
            r, g, b = colorsys.hsv_to_rgb( h, 0.25,brightness  )
            light.node().setColor( Vec4( r, g, b, 1 ) )
           
           # light.node().setColor( Vec4( self.amb,self.amb,self.amb, 1 ) )
    def addBrightnessDir( self, light, amount ):
            color = light.node().getColor()
            h, s, b = colorsys.rgb_to_hsv( color[0], color[1], color[2] )
            brightness = (b + amount)
            #print 'Dir=',brightness
            r, g, b = colorsys.hsv_to_rgb( h, s, brightness )
            light.node().setColor( Vec4( r, g, b, 1 ) )
    
            
        
#sozdaem klass, otvechayuschiy za upravlenie
KeyHandler()
#i zapuskaem osnovnoy cikl
run()    